Index: cpp/frams/model/defassign-f0-SDK.h
===================================================================
--- cpp/frams/model/defassign-f0-SDK.h	(revision 501)
+++ cpp/frams/model/defassign-f0-SDK.h	(revision 507)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -22,7 +22,7 @@
 vis_style="part";
 vsize=0.2;
-vcolor.x=0.5;
-vcolor.y=0.5;
-vcolor.z=0.5;
+vcolor.x=1.0;
+vcolor.y=1.0;
+vcolor.z=1.0;
 }
 
@@ -71,7 +71,7 @@
 stamina=0.25;
 vis_style="joint";
-vcolor.x=0.5;
-vcolor.y=0.5;
-vcolor.z=0.5;
+vcolor.x=1.0;
+vcolor.y=1.0;
+vcolor.z=1.0;
 }
 
Index: cpp/frams/model/f0-SDK-classes.h
===================================================================
--- cpp/frams/model/f0-SDK-classes.h	(revision 501)
+++ cpp/frams/model/f0-SDK-classes.h	(revision 507)
@@ -47,7 +47,7 @@
  {"Vstyle",2,0,"vis_style","s 0 -1 part",FIELD(vis_style),},
  {"vs",2,0,"visual thickness","f 0.05 0.7 0.2",FIELD(vsize),},
- {"vr",2,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
- {"vg",2,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
- {"vb",2,1024,"blue component","f 0.0 1.0 0.5",FIELD(vcolor.z),},
+ {"vr",2,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
+ {"vg",2,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
+ {"vb",2,1024,"blue component","f 0.0 1.0 1.0",FIELD(vcolor.z),},
  {0,0,0,}
 };
@@ -61,7 +61,7 @@
  {"as",0,0,"assimilation","f 0.0 1.0 0.25",FIELD(assim),},
  {"vs",0,0,"visual thickness","f 0.05 0.7 0.2",FIELD(vsize),},
- {"vr",0,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
- {"vg",0,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
- {"vb",0,1024,"blue component","f 0.0 1.0 0.5",FIELD(vcolor.z),},
+ {"vr",0,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
+ {"vg",0,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
+ {"vb",0,1024,"blue component","f 0.0 1.0 1.0",FIELD(vcolor.z),},
  {0,0,0,}
 };
@@ -90,7 +90,7 @@
  {"i",2,0,"info","s",FIELD(info),},
  {"Vstyle",3,0,"vis_style","s 0 -1 joint",FIELD(vis_style),},
- {"vr",3,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
- {"vg",3,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
- {"vb",3,1024,"blue component","f 0.0 1.0 0.5",FIELD(vcolor.z),},
+ {"vr",3,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
+ {"vg",3,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
+ {"vb",3,1024,"blue component","f 0.0 1.0 1.0",FIELD(vcolor.z),},
  {0,0,0,}
 };
@@ -100,7 +100,7 @@
  {"stif",0,0,"stiffness","f 0.0 1.0 1.0",FIELD(stif),},
  {"rotstif",0,0,"rotation stiffness","f 0.0 1.0 1.0",FIELD(rotstif),},
- {"vr",0,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
- {"vg",0,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
- {"vb",0,1024,"blue component","f 0.0 1.0 0.5",FIELD(vcolor.z),},
+ {"vr",0,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
+ {"vg",0,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
+ {"vb",0,1024,"blue component","f 0.0 1.0 1.0",FIELD(vcolor.z),},
  {0,0,0,}
 };
@@ -123,7 +123,7 @@
  {"i",2,0,"info","s",FIELD(info),},
  {"Vstyle",3,0,"vis_style","s 0 -1 joint",FIELD(vis_style),},
- {"vr",3,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
- {"vg",3,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
- {"vb",3,1024,"blue component","f 0.0 1.0 0.5",FIELD(vcolor.z),},
+ {"vr",3,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
+ {"vg",3,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
+ {"vb",3,1024,"blue component","f 0.0 1.0 1.0",FIELD(vcolor.z),},
  {0,0,0,}
 };
@@ -133,7 +133,7 @@
  {"stif",0,0,"stiffness","f 0.0 1.0 1.0",FIELD(stif),},
  {"rotstif",0,0,"rotation stiffness","f 0.0 1.0 1.0",FIELD(rotstif),},
- {"vr",0,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
- {"vg",0,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
- {"vb",0,1024,"blue component","f 0.0 1.0 0.5",FIELD(vcolor.z),},
+ {"vr",0,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
+ {"vg",0,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
+ {"vb",0,1024,"blue component","f 0.0 1.0 1.0",FIELD(vcolor.z),},
  {0,0,0,}
 };