Index: java/Framclipse/com.framsticks.framclipse/res/framscript.xml
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 509)
+++ java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 531)
@@ -187,4 +187,5 @@
 		<element name="numjoints" type="integer" flags="3"/>
 		<element name="numneurons" type="integer" flags="3"/>
+		<element name="numconnections" type="integer" flags="3"/>
 		<element name="data" type="Dictionary" flags="32768"/>
 		<element name="user1" type="untyped" deprecated="true" flags="8192"/>
@@ -1527,5 +1528,5 @@
 			<description><![CDATA[Additional information or comments]]></description>
 		</element>
-		<element name="format" type="integer" flags="257">
+		<element name="format" type="string" flags="257">
 			<description><![CDATA[Genotype format]]></description>
 		</element>
@@ -1543,5 +1544,5 @@
 		<element name="getConverted" function="true" type="Geno" flags="256">
 			<arguments>
-				<argument name="format" type="integer"/>
+				<argument name="format" type="string"/>
 			</arguments>
 		</element>
@@ -1558,5 +1559,5 @@
 			<arguments>
 				<argument name="genotype" type="string"/>
-				<argument name="format" type="integer"/>
+				<argument name="format" type="string"/>
 				<argument name="name" type="string"/>
 				<argument name="description" type="string"/>
@@ -2812,5 +2813,4 @@
 		<element name="y" type="float" flags="1024"/>
 		<element name="z" type="float" flags="1024"/>
-		<element name="m" type="float" min="0.1" max="999" default="1.0"/>
 		<element name="sh" type="integer" min="0" max="3" default="0"/>
 		<element name="s" type="float" min="0.1" max="10" default="1.0"/>
@@ -3380,7 +3380,10 @@
 		<element name="expdef_info" type="string" flags="3"/>
 		<element name="init" function="true" type="void">
-			<description><![CDATA[Performs initialization procedures, like resetting counters, states, gene pools, etc.]]></description>
+			<description><![CDATA[Prepares the experiment for running - usually performs initialization procedures such as resetting counters, states, gene pools, etc.
+These actions are defined in the onInit() function of this experiment definition.]]></description>
 <arguments/></element>
-		<element name="loadexpdef" function="true" type="void"><arguments/></element>
+		<element name="loadexpdef" function="true" type="void">
+			<description><![CDATA[Resets the simulator to its default state, resets all parameters to default values and then loads this experiment definition.]]></description>
+<arguments/></element>
 		<element name="usercode" type="string" min="1">
 			<description><![CDATA[You can override any function from the original experiment definition script. Use the same function names and provide alternative implementations.
@@ -4540,7 +4543,10 @@
 		<element name="expdef_info" type="string" flags="3"/>
 		<element name="init" function="true" type="void">
-			<description><![CDATA[Performs initialization procedures, like resetting counters, states, gene pools, etc.]]></description>
+			<description><![CDATA[Prepares the experiment for running - usually performs initialization procedures such as resetting counters, states, gene pools, etc.
+These actions are defined in the onInit() function of this experiment definition.]]></description>
 <arguments/></element>
-		<element name="loadexpdef" function="true" type="void"><arguments/></element>
+		<element name="loadexpdef" function="true" type="void">
+			<description><![CDATA[Resets the simulator to its default state, resets all parameters to default values and then loads this experiment definition.]]></description>
+<arguments/></element>
 		<element name="usercode" type="string" min="1">
 			<description><![CDATA[You can override any function from the original experiment definition script. Use the same function names and provide alternative implementations.
@@ -5625,4 +5631,5 @@
 		<element name="numjoints" type="integer" flags="3"/>
 		<element name="numneurons" type="integer" flags="3"/>
+		<element name="numconnections" type="integer" flags="3"/>
 		<element name="data" type="Dictionary" flags="32768"/>
 		<element name="user1" type="untyped" deprecated="true" flags="8192"/>
@@ -6024,5 +6031,4 @@
 		<element name="y" type="float" flags="1024"/>
 		<element name="z" type="float" flags="1024"/>
-		<element name="m" type="float" min="0.1" max="999" default="1.0"/>
 		<element name="sh" type="integer" min="0" max="3" default="0"/>
 		<element name="s" type="float" min="0.1" max="10" default="1.0"/>