Index: cpp/frams/_demos/f0_variants_test.cpp
===================================================================
--- cpp/frams/_demos/f0_variants_test.cpp	(revision 532)
+++ cpp/frams/_demos/f0_variants_test.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -94,5 +94,5 @@
 	}
 Geno g(gen);
-printf("\nSource genotype: '%s'\n",g.getGene().c_str());
+printf("\nSource genotype: '%s'\n",g.getGenes().c_str());
 printf("                  ( format %c %s)\n",
        g.getFormat(), g.getComment().c_str());
Index: cpp/frams/_demos/full_props.cpp
===================================================================
--- cpp/frams/_demos/full_props.cpp	(revision 532)
+++ cpp/frams/_demos/full_props.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -97,5 +97,5 @@
 Geno f0_g;
 m.makeGeno(f0_g,NULL,reverse);//third arg is "handle_defaults" == whether f0 should omit default property values
-puts(f0_g.getGeneAndFormat().c_str());
+puts(f0_g.getGenesAndFormat().c_str());
 
 return 0;
Index: cpp/frams/_demos/genoconv_test.cpp
===================================================================
--- cpp/frams/_demos/genoconv_test.cpp	(revision 532)
+++ cpp/frams/_demos/genoconv_test.cpp	(revision 534)
@@ -51,5 +51,5 @@
 mod.getPart(1)->p=Pt3D(0,0.2,-1);
 mod.close();
-return mod.getGeno().getGene();
+return mod.getGeno().getGenes();
 }
 ~GenoConv_Test2() {}
@@ -112,5 +112,5 @@
 {
 printf("Genotype:\n%s\nFormat: %c\nValid: %s\nComment: %s\n",
-	g.getGene().c_str(),g.getFormat(),g.isValid()?"yes":"no",g.getComment().c_str());
+	g.getGenes().c_str(),g.getFormat(),g.isValid()?"yes":"no",g.getComment().c_str());
 }
 
@@ -159,19 +159,19 @@
 	printf("conversion map:\n");
 	m.print();
-	printConvMap(g1.getGene(),g2.getGene(),m);
+	printConvMap(g1.getGenes(),g2.getGenes(),m);
 	printf("reverse conversion map:\n");
 	MultiMap rm;
 	rm.addReversed(m);
 	rm.print();
-	printConvMap(g2.getGene(),g1.getGene(),rm);
+	printConvMap(g2.getGenes(),g1.getGenes(),rm);
 	}
 
 Model mod1(g1,1);
 printf("\nmodel map for f%c genotype:\n",g1.getFormat());
-printModelMap(g1.getGene(),mod1.getMap());
+printModelMap(g1.getGenes(),mod1.getMap());
 mod1.getMap().print();
 Model mod2(g2,1);
 printf("\nmodel map for f%c genotype:\n",g2.getFormat());
-printModelMap(g2.getGene(),mod2.getMap());
+printModelMap(g2.getGenes(),mod2.getMap());
 mod2.getMap().print();
 return 0;
Index: cpp/frams/_demos/genomanipulation.cpp
===================================================================
--- cpp/frams/_demos/genomanipulation.cpp	(revision 532)
+++ cpp/frams/_demos/genomanipulation.cpp	(revision 534)
@@ -79,5 +79,5 @@
 CHANGE_ONE_PROPERTY(p->extraProperties());
 p->getModel().close();
-printf("\nLet's see f0... (check out part #%d !)\n\n%s\n", p->refno, p->getModel().getF0Geno().getGene().c_str());
+printf("\nLet's see f0... (check out part #%d !)\n\n%s\n", p->refno, p->getModel().getF0Geno().getGenes().c_str());
 }
 
@@ -91,5 +91,5 @@
 j->getModel().close();
 printf("The Part's position is changed, but everything else stays intact:\n\n%s\n",
-       j->getModel().getF0Geno().getGene().c_str());
+       j->getModel().getF0Geno().getGenes().c_str());
 }
 
@@ -104,5 +104,5 @@
 j->getModel().close();
 printf("Position of the second Part referenced by this joint (part #%d) is now changed:\n\n%s\n",
-       j->part2->refno, j->getModel().getF0Geno().getGene().c_str());
+       j->part2->refno, j->getModel().getF0Geno().getGenes().c_str());
 printf("If no delta fields are defined, they will be computed automatically.\n"
        "You can always delete existing delta values by using Joint::resetDelta().\n"
@@ -112,5 +112,5 @@
 j->resetDelta();
 j->getModel().close();
-printf("As you can see, Joint's delta fields have altered:\n\n%s\n", j->getModel().getF0Geno().getGene().c_str());
+printf("As you can see, Joint's delta fields have altered:\n\n%s\n", j->getModel().getF0Geno().getGenes().c_str());
 }
 
@@ -123,5 +123,5 @@
 j->getModel().close();
 printf("f0 is now:\n\n%s\n...so this is %s joint.\n",
-       j->getModel().getF0Geno().getGene().c_str(), option?"a delta":"an absolute");
+       j->getModel().getF0Geno().getGenes().c_str(), option?"a delta":"an absolute");
 
 }
@@ -155,5 +155,5 @@
 CHANGE_ONE_PROPERTY(j->extraProperties());
 j->getModel().close();
-printf("And after that we have this genotype:\n\n%s\n", j->getModel().getF0Geno().getGene().c_str());
+printf("And after that we have this genotype:\n\n%s\n", j->getModel().getF0Geno().getGenes().c_str());
 }
 
@@ -250,5 +250,5 @@
 n->getModel().close();
 printf("The final object description will be then: '%s'\nAnd the full f0 genotype:\n\n%s\n",
-       n->getDetails().c_str(), n->getModel().getF0Geno().getGene().c_str());
+       n->getDetails().c_str(), n->getModel().getF0Geno().getGenes().c_str());
 
 
@@ -281,5 +281,5 @@
 	}
 Geno g(gen);
-printf("\nSource genotype: '%s'\n",g.getGene().c_str());
+printf("\nSource genotype: '%s'\n",g.getGenes().c_str());
 printf("                  ( format %c %s)\n",
        g.getFormat(), g.getComment().c_str());
@@ -292,5 +292,5 @@
 	return 2;	
 	}
-printf("Converted to f0:\n%s\n",m.getF0Geno().getGene().c_str());
+printf("Converted to f0:\n%s\n",m.getF0Geno().getGenes().c_str());
 
 printf("Model contains: %d part(s)\n"
Index: cpp/frams/_demos/genooper_test.cpp
===================================================================
--- cpp/frams/_demos/genooper_test.cpp	(revision 532)
+++ cpp/frams/_demos/genooper_test.cpp	(revision 534)
@@ -9,5 +9,5 @@
 {
 	printf("Genotype: %s\nFormat: %c\nValid: %s\nComment: %s\n",
-		g.getGene().c_str(), g.getFormat(), g.isValid() ? "yes" : "no", g.getComment().len() == 0 ? "(empty)" : g.getComment().c_str());
+		g.getGenes().c_str(), g.getFormat(), g.isValid() ? "yes" : "no", g.getComment().len() == 0 ? "(empty)" : g.getComment().c_str());
 }
 
@@ -47,5 +47,5 @@
 	printGenAndTitle(gvalidated, "validated");
 
-	printf("\nHTMLized: %s\n", genetics.genman.HTMLize(gvalidated.getGene().c_str()).c_str());
+	printf("\nHTMLized: %s\n", genetics.genman.HTMLize(gvalidated.getGenes().c_str()).c_str());
 
 	return 0;
Index: cpp/frams/_demos/geometry/apices_test.cpp
===================================================================
--- cpp/frams/_demos/geometry/apices_test.cpp	(revision 532)
+++ cpp/frams/_demos/geometry/apices_test.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -47,5 +47,5 @@
 	// Finishing result Model and printing its genotype.
 	resultModel.close();
-	puts(resultModel.getF0Geno().getGeneAndFormat().c_str());
+	puts(resultModel.getF0Geno().getGenesAndFormat().c_str());
 }
 
Index: cpp/frams/_demos/geometry/info_test.cpp
===================================================================
--- cpp/frams/_demos/geometry/info_test.cpp	(revision 532)
+++ cpp/frams/_demos/geometry/info_test.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -72,5 +72,5 @@
 	// Finishing result Model and printing its genotype.
 	resultModel.close();
-	puts(resultModel.getF0Geno().getGeneAndFormat().c_str());
+	puts(resultModel.getF0Geno().getGenesAndFormat().c_str());
 	
 	// Printing calculated values.
Index: cpp/frams/_demos/geometry/surface_test.cpp
===================================================================
--- cpp/frams/_demos/geometry/surface_test.cpp	(revision 532)
+++ cpp/frams/_demos/geometry/surface_test.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -47,5 +47,5 @@
 	// Finishing result Model and printing its genotype.
 	resultModel.close();
-	puts(resultModel.getF0Geno().getGeneAndFormat().c_str());
+	puts(resultModel.getF0Geno().getGenesAndFormat().c_str());
 }
 
Index: cpp/frams/_demos/geometry/volume_test.cpp
===================================================================
--- cpp/frams/_demos/geometry/volume_test.cpp	(revision 532)
+++ cpp/frams/_demos/geometry/volume_test.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -39,5 +39,5 @@
 	// Finishing result Model and printing its genotype.
 	resultModel.close();
-	puts(resultModel.getF0Geno().getGeneAndFormat().c_str());
+	puts(resultModel.getF0Geno().getGenesAndFormat().c_str());
 }
 
Index: cpp/frams/_demos/multiline_f0_test.cpp
===================================================================
--- cpp/frams/_demos/multiline_f0_test.cpp	(revision 532)
+++ cpp/frams/_demos/multiline_f0_test.cpp	(revision 534)
@@ -26,5 +26,5 @@
 	}
 Geno g(gen);
-printf("\nSource genotype: '%s'\n",g.getGene().c_str());
+printf("\nSource genotype: '%s'\n",g.getGenes().c_str());
 printf("                  ( format %c %s)\n",
        g.getFormat(), g.getComment().c_str());
@@ -37,5 +37,5 @@
 	return 2;	
 	}
-printf("Converted to f0:\n%s\n",m.getF0Geno().getGene().c_str());
+printf("Converted to f0:\n%s\n",m.getF0Geno().getGenes().c_str());
 
 printf("\nusing Param::save() to create the \"expanded\" form of the f0 genotype...\n(MultiParamLoader should be able to load this)");
Index: cpp/frams/_demos/part_shapes.cpp
===================================================================
--- cpp/frams/_demos/part_shapes.cpp	(revision 532)
+++ cpp/frams/_demos/part_shapes.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -52,5 +52,5 @@
 
 	m.close();
-	puts(m.getF0Geno().getGeneAndFormat().c_str());
+	puts(m.getF0Geno().getGenesAndFormat().c_str());
 	// the genotype can be fed directly to the genotype viewer, like this:
 	// part_shapes | theater -g -
Index: cpp/frams/_demos/shapeconvert.cpp
===================================================================
--- cpp/frams/_demos/shapeconvert.cpp	(revision 532)
+++ cpp/frams/_demos/shapeconvert.cpp	(revision 534)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -87,5 +87,5 @@
 
 	Geno f0_g = newmodel.getF0Geno();
-	puts(f0_g.getGeneAndFormat().c_str());
+	puts(f0_g.getGenesAndFormat().c_str());
 
 	return 0;